// XEdit.cpp : implementation file
//

#include "stdafx.h"
#include "IOEdit.h"
#include "XEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void UpdateCaret(CEdit* pEdit, BOOL bInsert)
{
	CFont* pFont = pEdit->GetFont();
	CDC* pDC = pEdit->GetDC();
	CFont* pOldFont = pDC->SelectObject(pFont);
	CSize sizeChar = pDC->GetTextExtent("0");
	if (bInsert)
	{
		// Insert mode, vertical line caret
		sizeChar.cx = 0;
	}
	else
	{
		// Checks whether caret is at the end of current line
		int nLineIndex = pEdit->LineIndex();
		int nLineLength = pEdit->LineLength();
		int nStart, nEnd;
		pEdit->GetSel(nStart, nEnd);
		if (nStart == nEnd && nStart != nLineIndex + nLineLength)
		{
			// No text selected & caret is not at end of line
			// So, gets next character
			char* strLine = new char[nLineLength + 1];
			pEdit->GetLine(pEdit->LineFromChar(), strLine, nLineLength);
			strLine[nStart - nLineIndex + 1] = 0;
			// Sets caret size as size of next character
			sizeChar = pDC->GetTextExtent(strLine + (nStart - nLineIndex));
			delete[] strLine;
		}
	}
	// Destroys previous caret and displays new caret
	DestroyCaret();
	pEdit->HideCaret();
	pEdit->CreateSolidCaret(sizeChar.cx, sizeChar.cy);
	pEdit->ShowCaret();
	// Stores caret width in application object
	((CIOEditApp*) AfxGetApp())->m_nCaretWidth = sizeChar.cx;
	pDC->SelectObject(pOldFont);
}

void DeleteNextChar(CEdit* pEdit)
{
	int Start, End;
	pEdit->GetSel(Start, End);
	pEdit->ReplaceSel("");
	pEdit->SetSel(Start, End + 1);
	pEdit->ReplaceSel("");
}

/////////////////////////////////////////////////////////////////////////////
// CXEdit

CXEdit::CXEdit()
{
	m_bInsert = TRUE;
}

CXEdit::~CXEdit()
{
}


BEGIN_MESSAGE_MAP(CXEdit, CEdit)
	//{{AFX_MSG_MAP(CXEdit)
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXEdit message handlers

BOOL CXEdit::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	switch (pMsg->message)
	{
	case (WM_KEYDOWN):
	case (WM_KEYUP):
	case (WM_LBUTTONDOWN):
	case (WM_LBUTTONUP):
	case (WM_SETFOCUS):
		{
			UpdateCaret(this, m_bInsert);
			break;
		}
	case (WM_CHAR):
		{
			if (!m_bInsert)
				DeleteNextChar(this);
			break;
		}
	}
	return CEdit::PreTranslateMessage(pMsg);
}

void CXEdit::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	if (nChar == VK_INSERT)
		m_bInsert = !m_bInsert;
	CEdit::OnKeyDown(nChar, nRepCnt, nFlags);
}
